Package com.avaya.clientservices.call

## Enum CallPreemptionReason

- java.lang.Object
- - java.lang.Enum<CallPreemptionReason>
  - - com.avaya.clientservices.call.CallPreemptionReason

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Comparable<CallPreemptionReason>`

      public enum CallPreemptionReason
      extends java.lang.Enum<CallPreemptionReason>

  Call Preemption reasons based on Reason Header for Preemption Events (RFC 4411) - IETF and Department of Defense Unified Capabilities Requirements 2013. Call preemption occurs when a precedence call is sent to a preemptable endpoint that is busy with a call of lower precedence and has no idle appearances. This causes the lower precedence call to be preempted, regardless of whether the lower precedence call and the new higher precedence call are of the same media type. When preemption occurs, the active busy user receive a continuous preemption tone until user acknowledges the preemption by invoking complete preemption method and the other party receives a preemption tone for a minimum of 3 seconds. After acknowledging the preemption, the extension to which the precedence call is directed will be provided with precedence ringing and the calling party will receive an audible ring-back precedence tone. Preemption may take one of two forms. First, the called party may be busy with a lower precedence call that is preempted in favor of completing the higher precedence call from the calling party. Second, the network resources may be busy with calls; some of which are of lower precedence than the call requested by the calling party. One or more of these lower precedence calls are preempted in order to complete the higher precedence call.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `GENERIC_PREEMPTION` | This is a limited-use preemption indication to be used on the final leg to the preempted UA to generalize the event.
    `NETWORK_PREEMPTION` | Reason-params in RFC 4411 fails to fully meet Department of Defense needs, the AS-SIP signaling appliances support a fifth Reason-param intended to characterize a network preemption event that occurs in the IP portion of the network but is not due to a RSVP preemption occurrence.
    `NON_IP_PREEMPTION` | The call preemption has occurred in a non-IP portion of the infrastructure, and this is the Reason cause code given by the SIP Gateway.
    `NONE` | The call is not preempted.
    `RESERVED_RESOURCES_PREEMPTED` | The call preemption has been initiated within the network via a purposeful RSVP(Resource ReSerVation Protocol) preemption occurrence, and not a link error.
    `UA_PREEMPTION` | The call has been preempted by a UA(User Agent).

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static CallPreemptionReason` | `valueOf​(java.lang.String name)` | Returns the enum constant of this type with the specified name.
    `static CallPreemptionReason[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `compareTo, equals, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### NONE

          public static final CallPreemptionReason NONE

      The call is not preempted.

    - #### UA_PREEMPTION

          public static final CallPreemptionReason UA_PREEMPTION

      The call has been preempted by a UA(User Agent). UA Preemption occurs when called party may be busy with a lower precedence call that is preempted in favor of completing the higher precedence call from the calling party.

    - #### RESERVED_RESOURCES_PREEMPTED

          public static final CallPreemptionReason RESERVED_RESOURCES_PREEMPTED

      The call preemption has been initiated within the network via a purposeful RSVP(Resource ReSerVation Protocol) preemption occurrence, and not a link error.

    - #### GENERIC_PREEMPTION

          public static final CallPreemptionReason GENERIC_PREEMPTION

      This is a limited-use preemption indication to be used on the final leg to the preempted UA to generalize the event.

    - #### NON_IP_PREEMPTION

          public static final CallPreemptionReason NON_IP_PREEMPTION

      The call preemption has occurred in a non-IP portion of the infrastructure, and this is the Reason cause code given by the SIP Gateway.

    - #### NETWORK_PREEMPTION

          public static final CallPreemptionReason NETWORK_PREEMPTION

      Reason-params in RFC 4411 fails to fully meet Department of Defense needs, the AS-SIP signaling appliances support a fifth Reason-param intended to characterize a network preemption event that occurs in the IP portion of the network but is not due to a RSVP preemption occurrence.

  - ### Method Detail

    - #### values

          public static CallPreemptionReason[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (CallPreemptionReason c : CallPreemptionReason.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static CallPreemptionReason valueOf​(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null